/***********************************************************************
 * saveCurve.pde - Processing sketch for drawing a curve and saving its 
 * parameters.
 ***********************************************************************/

int x2 = 35;
int y2 = 75;
int x3 = 100;

// f(x)

float a1, b1, fx3, a2, b2, c2, gx1, gy1, angle1;

int fx1 = 0;
int fy1 = 0;
float fx2 = x2;
float fy2 = y2;
int fy3 = 0;
float c1 = 0;

//g(x)

float gx2 = x2;
float gy2 = y2;
float gx3 = x3;
int gy3 = 0;

int punkt = 0;

int ypos1, xpos1, ypos2, xpos2, ypos3, xpos3;

PVector v1, v2, v3, v4, v5;

int xposv2, yposv2, xposv3, yposv3, xposv4, yposv4, xposv5, yposv5; 
int xpos3w, ypos3w, xpos2w, ypos2w; // Scheinvariablen für Winkel und mag5

PrintWriter output;

int zoom = 1;
int ellipsesize = 4;
int pointSize = 4;

int transX = width/2;
int transY = height/2;

PImage img;

void setup() {

  size(800, 549);
  smooth();
  background(255);
  stroke(0);
  line(width/2, 0, width/2, height);
  line(0, height/2, width, height/2);

  output = createWriter("data.txt");
//  img = loadImage("isles.png");
  xposv3 = 0;
  yposv3 = 0;
  transX = width/2;
  transY = height/2;
}

void draw() {

  background(255);
  //image(img, 0, 0);
  stroke(0);
  line(width/2, 0, width/2, height);
  line(0, height/2, width, height/2);
  int mouseXpos = (mouseX-transX);
  int mouseYpos = -1*(mouseY-transY);

  pushMatrix();
  translate(transX, transY);
  rotate(PI);
  scale(-1, 1);

  noCursor();
  line(mouseXpos-5, mouseYpos - 5, mouseXpos+5, mouseYpos + 5 );
  line(mouseXpos-5, mouseYpos + 5, mouseXpos + 5, mouseYpos - 5 );

  // Vectors

  v1 = new PVector(10, 0);

  v2 = new PVector(xposv2, yposv2);
  float mag2 = v2.mag();
  float magv2 = mag2;
  angle1 = PVector.angleBetween(v1, v2);

  PVector v20 = PVector.div(v2, mag2);

  v3 = new PVector(xposv3, yposv3);

  float skav2v20 = v3.dot(v20);

  PVector v4 = PVector.mult(v20, skav2v20);
  float mag4 = v4.mag();

  PVector v5 = PVector.sub(v3, v4);
  float mag5 = v5.mag();

  // set x3, y3

  if (mousePressed == true && punkt%3 == 0) {
    xpos3 = mouseXpos;
    ypos3 = 0;
    xpos3w = mouseXpos;
    ypos3w = mouseYpos;
    xposv2 = mouseXpos;
    yposv2 = mouseYpos;
  }

  // set x2, y2

  if (mousePressed == true && punkt%3 == 1) {
    xpos2 = mouseXpos;
    ypos2 = mouseYpos;
    xposv3 = mouseXpos;
    yposv3 = mouseYpos;
    ypos2w = mouseYpos;
    xpos2w = mouseXpos;
  }

  // set 0
  if (mousePressed == true && punkt%3 == 2) {
    xpos3 = 0;
    xpos2 = 0;
    ypos2 = 0;
    xposv3 = 0;
    yposv3 = 0;
  }

  if (xpos3w > 0 && xpos2w < 0) {
    mag5*=-1;
  }
  if (xpos3w < 0 && xpos2w > 0) {
    mag5*=-1;
  }
  if (ypos3w < 0) {
    angle1*=-1;
  }

  if (ypos2w < v4.y && xpos2w > 0) {
    mag5*=-1;
  }

  if (ypos2w > v4.y && xpos2w < 0) {
    mag5*=-1;
  }

  x2 = int(mag4)/zoom;
  y2 = int(mag5);
  x3 = int(mag2)/zoom;

  int fx2 = x2;
  int fy2 = y2;
  int gx2 = x2;
  int gy2 = y2;
  int gx3 = x3;

  // Calc f(x)

  b1 = (2*fx2*fy2)/(pow(fx2, 2)-2*fx2*fx3+pow(fx3, 2));
  a1 = -b1/(2*fx2);
  c1 = -(b1*fx2-2*fy2)/2;

  //Calc g(x)

  b2 = (2*gx2*gy2)/(pow(gx2, 2)-2*gx2*gx3+pow(gx3, 2));
  a2 = -b2/(2*gx2);
  c2 = -(b2*gx2-2*gy2)/2;

  popMatrix();

  function(a1, b1, c1, 0, zoom*x2, angle1, transX, transY);
  function(a2, b2, c2, zoom*x2, zoom*x3, angle1, transX, transY);
}

void mouseReleased() {
  int mouseXpos = (mouseX-transX);
  int mouseYpos = -1*(mouseY-transY);

  punkt ++;

  if (punkt %3 == 0 && punkt!= 0) {
    if (punkt != 2) {
      transX = transX+(xpos3w);
      transY = transY-ypos3w;
    }
  }
  if (punkt % 3 == 2 && punkt!=3) {


    output.println(angle1+"\t"+x2+"\t"+x3+"\t"+a1+"\t"+b1+"\t"+a2+"\t"+b2+"\t"+c2+"\t"+transX+"\t"+transY); 
    println(angle1+"\t"+x2+"\t"+x3+"\t"+a1+"\t"+b1+"\t"+a2+"\t"+b2+"\t"+c2+"\t"+transX+"\t"+transY);
    output.flush();
  }
}

void function (float a, float b, float c, int lowbound, int upbound, float angle, int translateX, int translateY) {
  pushMatrix();
  translate(translateX, translateY);
  rotate(PI);
  scale(-1, 1);
  rotate (angle);
  for (int x = lowbound; x < upbound; x++) {
    float f1 = map(x, -width, width, -width/zoom, width/zoom);
    float f2 = map(x+1, -width, width, -width/zoom, width/zoom);
    float y = a*pow(f1, 2)+b*f1+c;
    float ff2 = a*pow(f2, 2)+b*f2+c;
    if (x < upbound && x > lowbound) {
      stroke(0);
      strokeWeight(1);
   //   point(x, y);
       line(x, y, x+1, ff2);
    }
  }

  fill(0);
  ellipse(0, 0, pointSize, pointSize); 
  ellipse(x2*zoom, y2, pointSize, pointSize);
  ellipse(x3*zoom, ypos3, pointSize, pointSize);
  popMatrix();
}
